/*
CVE Services API

The CVE Services API supports automation tooling for the CVE Program. Credentials are     required for most service endpoints. Representatives of     <a href='https://www.cve.org/ProgramOrganization/CNAs'>CVE Numbering Authorities (CNAs)</a> should     use one of the methods below to obtain credentials:    <ul><li>If your organization already has an Organizational Administrator (OA) account for the CVE     Services, ask your admin for credentials</li>     <li>Contact your Root (<a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/Google'>Google</a>,     <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/INCIBE'>INCIBE</a>,     <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/jpcert'>JPCERT/CC</a>, or     <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/redhat'>Red Hat</a>) or     Top-Level Root (<a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/icscert'>CISA ICS</a>     or <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/mitre'>MITRE</a>) to request credentials     </ul>     <p>CVE data is to be in the JSON 5.0 CVE Record format. Details of the JSON 5.0 schema are     located <a href='https://github.com/CVEProject/cve-schema/tree/master/schema/v5.0' target='_blank'>here</a>.</p>    <a href='https://cveform.mitre.org/' class='link' target='_blank'>Contact the CVE Services team</a>

API version: 2.1.4
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package cveapi

import (
	"encoding/json"
)

// checks if the GetCveRecordResponseContainersCnaProblemTypesInner type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &GetCveRecordResponseContainersCnaProblemTypesInner{}

// GetCveRecordResponseContainersCnaProblemTypesInner struct for GetCveRecordResponseContainersCnaProblemTypesInner
type GetCveRecordResponseContainersCnaProblemTypesInner struct {
	Descriptions []GetCveRecordResponseContainersCnaProblemTypesInnerDescriptionsInner `json:"descriptions,omitempty"`
}

// NewGetCveRecordResponseContainersCnaProblemTypesInner instantiates a new GetCveRecordResponseContainersCnaProblemTypesInner object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewGetCveRecordResponseContainersCnaProblemTypesInner() *GetCveRecordResponseContainersCnaProblemTypesInner {
	this := GetCveRecordResponseContainersCnaProblemTypesInner{}
	return &this
}

// NewGetCveRecordResponseContainersCnaProblemTypesInnerWithDefaults instantiates a new GetCveRecordResponseContainersCnaProblemTypesInner object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewGetCveRecordResponseContainersCnaProblemTypesInnerWithDefaults() *GetCveRecordResponseContainersCnaProblemTypesInner {
	this := GetCveRecordResponseContainersCnaProblemTypesInner{}
	return &this
}

// GetDescriptions returns the Descriptions field value if set, zero value otherwise.
func (o *GetCveRecordResponseContainersCnaProblemTypesInner) GetDescriptions() []GetCveRecordResponseContainersCnaProblemTypesInnerDescriptionsInner {
	if o == nil || IsNil(o.Descriptions) {
		var ret []GetCveRecordResponseContainersCnaProblemTypesInnerDescriptionsInner
		return ret
	}
	return o.Descriptions
}

// GetDescriptionsOk returns a tuple with the Descriptions field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GetCveRecordResponseContainersCnaProblemTypesInner) GetDescriptionsOk() ([]GetCveRecordResponseContainersCnaProblemTypesInnerDescriptionsInner, bool) {
	if o == nil || IsNil(o.Descriptions) {
		return nil, false
	}
	return o.Descriptions, true
}

// HasDescriptions returns a boolean if a field has been set.
func (o *GetCveRecordResponseContainersCnaProblemTypesInner) HasDescriptions() bool {
	if o != nil && !IsNil(o.Descriptions) {
		return true
	}

	return false
}

// SetDescriptions gets a reference to the given []GetCveRecordResponseContainersCnaProblemTypesInnerDescriptionsInner and assigns it to the Descriptions field.
func (o *GetCveRecordResponseContainersCnaProblemTypesInner) SetDescriptions(v []GetCveRecordResponseContainersCnaProblemTypesInnerDescriptionsInner) {
	o.Descriptions = v
}

func (o GetCveRecordResponseContainersCnaProblemTypesInner) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o GetCveRecordResponseContainersCnaProblemTypesInner) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Descriptions) {
		toSerialize["descriptions"] = o.Descriptions
	}
	return toSerialize, nil
}

type NullableGetCveRecordResponseContainersCnaProblemTypesInner struct {
	value *GetCveRecordResponseContainersCnaProblemTypesInner
	isSet bool
}

func (v NullableGetCveRecordResponseContainersCnaProblemTypesInner) Get() *GetCveRecordResponseContainersCnaProblemTypesInner {
	return v.value
}

func (v *NullableGetCveRecordResponseContainersCnaProblemTypesInner) Set(val *GetCveRecordResponseContainersCnaProblemTypesInner) {
	v.value = val
	v.isSet = true
}

func (v NullableGetCveRecordResponseContainersCnaProblemTypesInner) IsSet() bool {
	return v.isSet
}

func (v *NullableGetCveRecordResponseContainersCnaProblemTypesInner) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableGetCveRecordResponseContainersCnaProblemTypesInner(val *GetCveRecordResponseContainersCnaProblemTypesInner) *NullableGetCveRecordResponseContainersCnaProblemTypesInner {
	return &NullableGetCveRecordResponseContainersCnaProblemTypesInner{value: val, isSet: true}
}

func (v NullableGetCveRecordResponseContainersCnaProblemTypesInner) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableGetCveRecordResponseContainersCnaProblemTypesInner) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


